package cz.muni.fi.pb162.graphics;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import junit.framework.TestCase;

/**
 * Test class for AbstractGraphicShape
 *
 * @author Jan Pavlovic
 * @author Petr Adamek
 */
public class AbstractGraphicShapeTest extends TestCase {
    
    public AbstractGraphicShapeTest(String testName) {
        super(testName);
    }

    public void testMethodsAndAttributes() {
	BasicRulesTester.testMethodsAndAttributes(CircleImpl.class);
    }

    public void testColorAttribute() {
        Field colorField = null;
        try {
            colorField = AbstractGraphicShape.class.getDeclaredField("color");
        } catch (NoSuchFieldException ex) {
            fail("Trida AbstractGraphicShape neobsahje atribut color");
        }
        assertEquals("Atribut color neni typu Color",
                Color.class,colorField.getType());
        assertTrue("Atriut color neni private",
                Modifier.isPrivate(colorField.getModifiers()));
    }

    public void testConstructor() {
        Constructor constructor = null;
        try {
            constructor = AbstractGraphicShape.class
                    .getDeclaredConstructor(Color.class);
            
        } catch (NoSuchMethodException ex) {
            fail("Trida AbstractGraphicShape nema pozadovany konstruktor " +
                    "s jednim parametrem typu Color");
        }
        assertTrue("Trida AbstractGraphicShape obsahuje nejaky zbytecny " +
                "konstruktor navic",AbstractGraphicShape.class.
                getDeclaredConstructors().length == 1);
    }
    
    public void testGetColor() {
        String msg = "Metoda getColor() nevraci barvu, ktera byla predana " +
                "jako parametr konstruktoru (chyba muze byt bud v konstruktoru," +
                "nebo v metode getColor())";
        
        AbstractGraphicShape instance = new AbstractGraphicShapeImpl(Color.GREEN);
        assertEquals(msg,Color.GREEN, instance.getColor());
        instance = new AbstractGraphicShapeImpl(Color.BLUE);
        assertEquals(msg,Color.BLUE, instance.getColor());
    }

    public void testToString() {
        Method toStringMethod = null;
        try {
            toStringMethod = AbstractGraphicShape.class.getMethod("toString");
        } catch (NoSuchMethodException ex) {
            fail("Trida nema metodu toString - to by nikdy nemelo nastat");
        }
        assertTrue("Metoda toString() ve tride AbstractGraphicShape by mela " +
                "byt abstraktni nebo zde nebyt definovana",
                Modifier.isAbstract(toStringMethod.getModifiers()) || 
                !toStringMethod.getDeclaringClass()
                .equals(AbstractGraphicShape.class));
    }

    private class AbstractGraphicShapeImpl extends AbstractGraphicShape {

        AbstractGraphicShapeImpl(Color color) {
            super(color);
        }

        public String toString() {
            throw new UnsupportedOperationException();
        }

        public double getArea() {
            throw new UnsupportedOperationException();
        }

    }

    
}
