package cz.muni.fi.pb162.graphics;

import java.lang.reflect.Method;
import junit.framework.TestCase;

/**
 *
 * @author Jan Pavlovic
 * @author Petr Adamek
 */
public class CircleImplTest extends TestCase {
    
    public CircleImplTest(String testName) {
	super(testName);
    }
    
    public void testMethodsAndAttributes() {
	BasicRulesTester.testMethodsAndAttributes(CircleImpl.class);
    }
    
    public void testNew() {
	Point center = new Point(12,-15);
	Circle circle = new CircleImpl(Color.RED,center,13.25);
	
	assertEquals("Metoda CircleImpl.getCenter() nevraci spravnou hodnotu",
		center,circle.getCenter());
	assertEquals("Metoda CircleImpl.getColor() nevraci spravnou hodnotu",
		Color.RED,circle.getColor());
	assertEquals("Metoda CircleImpl.getRadius() nevraci spravnou hodnotu",
		13.25,circle.getRadius());
	
	Point center2 = new Point(122,18);
	Circle circle2 = new CircleImpl(Color.BLUE,center2,11.0);
	
	assertEquals("Metoda CircleImpl.getCenter() nevraci spravnou hodnotu",
		center2,circle2.getCenter());
	assertEquals("Metoda CircleImpl.getColor() nevraci spravnou hodnotu",
		Color.BLUE,circle2.getColor());
	assertEquals("Metoda CircleImpl.getRadius() nevraci spravnou hodnotu",
		11.0,circle2.getRadius());
    }
    
    public void testGetArea() {
	Point center = new Point(12,-15);
	String msg = "Metoda CircleImpl.getArea() nevraci spravnou hodnotu";
	assertEquals(msg,551.5,new CircleImpl(Color.RED,center,13.25).getArea(),0.1);
	assertEquals(msg,Math.PI,new CircleImpl(Color.RED,center,1).getArea(),0.1);
    }
    
    public void testToString() {
	Point center = new Point(12,-15);
	Circle circle = new CircleImpl(Color.RED,center,13.25);
	
	BasicRulesTester.assertToString(circle,"Circle with center [12, -15]," +
		" radius 13.25 and color RED");
	
	Point center2 = new Point(122,18);
	Circle circle2 = new CircleImpl(Color.BLUE,center2,11.0);
	
	BasicRulesTester.assertToString(circle2,"Circle with center [122, 18]," +
		" radius 11.0 and color BLUE");
    }
    
    public void testGetColor() {
	BasicRulesTester.assertMethodDeclaredInAncestor("getColor",
		CircleImpl.class,AbstractGraphicShape.class);
    }
}
