package cz.muni.fi.pb162.graphics;

import java.lang.reflect.Method;
import junit.framework.TestCase;

/**
 *
 * @author Jan Pavlovic
 * @author Petr Adamek
 */
public class TriangleImplTest extends TestCase {
    
    public TriangleImplTest(String testName) {
	super(testName);
    }
        
    public void testMethodsAndAttributes() {
	BasicRulesTester.testMethodsAndAttributes(TriangleImpl.class);
    }
    
    private static void assertNewTriangle(Color color, Point vertexA, Point vertexB,
	    Point vertexC) {
	
	Triangle triangle = new TriangleImpl(color,vertexA,vertexB,vertexC);
	
	assertEquals("Metoda TriangleImpl.getVertexA() nevraci spravnou hodnotu",
		vertexA,triangle.getVertexA());
	assertEquals("Metoda TriangleImpl.getVertexB() nevraci spravnou hodnotu",
		vertexB,triangle.getVertexB());
	assertEquals("Metoda TriangleImpl.getVertexC() nevraci spravnou hodnotu",
		vertexC,triangle.getVertexC());
	assertEquals("Metoda TriangleImpl.getColor() nevraci spravnou hodnotu",
		color,triangle.getColor());
    }
    
    public void testNew() {
	assertNewTriangle(Color.RED,new Point(12,-15),new Point(11,18),new Point(1,123));
	assertNewTriangle(Color.GREEN,new Point(11,1),new Point(1,8),new Point(-12,-13));
    }

    public void testGetSide() {
    
	Triangle triangle = new TriangleImpl(Color.RED,new Point(12,-15),
		new Point(11,18),new Point(1,123));
	
	assertEquals("Metoda TriangleImpl.getSideA() nevraci spravnou hodnotu",
		105.5,triangle.getSideA(),0.1);
	assertEquals("Metoda TriangleImpl.getSideB() nevraci spravnou hodnotu",
		138.4,triangle.getSideB(),0.1);
	assertEquals("Metoda TriangleImpl.getSideC() nevraci spravnou hodnotu",
		33.0,triangle.getSideC(),0.1);

	triangle = new TriangleImpl(Color.RED,new Point(1,-15),
		new Point(111,-18),new Point(1234,13));
	assertEquals("Metoda TriangleImpl.getSideA() nevraci spravnou hodnotu",
		1123.4,triangle.getSideA(),0.1);
	assertEquals("Metoda TriangleImpl.getSideB() nevraci spravnou hodnotu",
		1233.3,triangle.getSideB(),0.1);
	assertEquals("Metoda TriangleImpl.getSideC() nevraci spravnou hodnotu",
                110.0,triangle.getSideC(),0.1);
    }
    
    public void testGetArea() {
	String msg = "Metoda TriangleImpl.getArea() nevraci spravnou hodnotu";
	assertEquals(msg,112.5,new TriangleImpl(Color.RED,new Point(12,-15),
		new Point(11,18),new Point(1,123)).getArea(),0.1);
	assertEquals(msg,601,new TriangleImpl(Color.RED,new Point(112,-115),
		new Point(111,18),new Point(102,13)).getArea(),0.1);
	assertEquals(msg,50.0,new TriangleImpl(Color.RED,new Point(0,0),
		new Point(10,0),new Point(0,10)).getArea(),0.1);
    }
    public void testToString() {
	
	Triangle triangle = new TriangleImpl(Color.RED,new Point(12,-15),
		new Point(11,18),new Point(1,123));
	Triangle triangle2 = new TriangleImpl(Color.BLUE,new Point(12,15),
		new Point(211,138),new Point(-11,-11));

	if (triangle.toString() != null && triangle.toString().contains("vertexes")) {
	    BasicRulesTester.assertToString(triangle,"Triangle with vertexes " +
		    "[12, -15], [11, 18], [1, 123] and color RED");
	    BasicRulesTester.assertToString(triangle2,"Triangle with vertexes " +
		    "[12, 15], [211, 138], [-11, -11] and color BLUE");
	} else {
	    BasicRulesTester.assertToString(triangle,"Triangle with vertices " +
		    "[12, -15], [11, 18], [1, 123] and color RED");
	    BasicRulesTester.assertToString(triangle2,"Triangle with vertices " +
		    "[12, 15], [211, 138], [-11, -11] and color BLUE");
	}
    }
    
    public void testGetColor() {
	BasicRulesTester.assertMethodDeclaredInAncestor("getColor",
		TriangleImpl.class,AbstractGraphicShape.class);
    }
}
